
foreman-tasks - Bug #28152

PG::ForeignKeyViolation when trying to add a relation to deleted users

10/30/2019 10:42 AM - Evgeni Golov

Status: Closed   

Priority: High   

Assignee: Adam Ruzicka   

Category:    

Target version:    

Difficulty:  Fixed in Releases: foreman-tasks-0.16.3,

foreman-tasks-0.17.1

Triaged: No Found in Releases: foreman-tasks-0.16.2

Bugzilla link: 1766948 Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman-t

asks/pull/470

  

Description

The migration added in https://projects.theforeman.org/issues/21083 / https://github.com/theforeman/foreman-tasks/pull/364 fails

when migrating a task that references a (now) not existing user:

[DEBUG 2019-10-30T11:03:33 main] PG::ForeignKeyViolation: ERROR:  insert or update on table "forem

an_tasks_tasks" violates foreign key constraint "fk_rails_a56904dd86" 

[DEBUG 2019-10-30T11:03:33 main] DETAIL:  Key (user_id)=(10) is not present in table "users".

[DEBUG 2019-10-30T11:03:33 main] : UPDATE "foreman_tasks_tasks" SET "user_id" = 10 WHERE "foreman_

tasks_tasks"."id" IN (SELECT "foreman_tasks_tasks"."id" FROM "foreman_tasks_tasks" INNER JOIN "for

eman_tasks_locks" ON "foreman_tasks_locks"."task_id" = "foreman_tasks_tasks"."id" WHERE "foreman_t

asks_tasks"."id" IN (SELECT "foreman_tasks_locks"."task_id" FROM "foreman_tasks_locks" WHERE "fore

man_tasks_locks"."name" = $1 AND "foreman_tasks_locks"."resource_id" = $2))

Related issues:

Related to foreman-tasks - Refactor #21083: Use explicit relation for task ->... Closed

Associated revisions

Revision 223788a5 - 11/06/2019 02:16 PM - Adam Ruzicka

Fixes #28152 - Link tasks with user only if the user exists (#470)

Commit 2f37f56957260facecdb278fffaa1b2bd7f94eb0 changed the way how we link

tasks to users. Before we used locks, but we didn't have any constraints in

place. This could lead to a situation, where a task has a lock, which links the

task to a user, which doesn't exist anymore. If we tried to perform the

migration introduced in that commit, it would fail with foreign key violation

errors.

History

#1 - 10/30/2019 10:42 AM - Evgeni Golov

- Related to Refactor #21083: Use explicit relation for task -> user association added

#2 - 10/30/2019 10:47 AM - Evgeni Golov

- Bugzilla link set to 1766948

#3 - 10/30/2019 01:26 PM - Patrick Thyen

After running a cleanup with:

"foreman-rake foreman_tasks:cleanup TASK_SEARCH='owner.id = 10' VERBOSE=true"

The Update works fine (assuming, there are no other deleted users, that trigger this problem).

#4 - 11/06/2019 09:28 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Adam Ruzicka
https://projects.theforeman.org/issues/21083
https://github.com/theforeman/foreman-tasks/pull/364


- Pull request https://github.com/theforeman/foreman-tasks/pull/470 added

#5 - 11/06/2019 02:16 PM - The Foreman Bot

- Fixed in Releases foreman-tasks-0.17.1 added

#6 - 11/06/2019 03:01 PM - Anonymous

- Status changed from Ready For Testing to Closed

Applied in changeset 223788a5313594b26ea488a3edccd46128890433.

#7 - 11/08/2019 03:35 PM - Adam Ruzicka

- Fixed in Releases foreman-tasks-0.16.3 added
